﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SelectDeSelectRowsOnSingleClick_CS
{
    public partial class MainPage : UserControl, INotifyPropertyChanged
    {
        ObservableCollection<PersonName> people = new ObservableCollection<PersonName>();
        List<int> selectedRows = new List<int>();
        public MainPage()
        {
            InitializeComponent();
            people.Add(new PersonName("Johnathan", "Gartner"));
            people.Add(new PersonName("Jeannine", "Richart"));
            people.Add(new PersonName("Merry", "Sparacino"));
            people.Add(new PersonName("Sandi", "Willman"));
            people.Add(new PersonName("Damion", "Dagley"));
            people.Add(new PersonName("Johnathan", "Gartner"));
            people.Add(new PersonName("Jeannine", "Richart"));
            people.Add(new PersonName("Merry", "Sparacino"));
            people.Add(new PersonName("Sandi", "Willman"));
            people.Add(new PersonName("Damion", "Dagley"));
            people.Add(new PersonName("Johnathan", "Gartner"));
            people.Add(new PersonName("Jeannine", "Richart"));
            people.Add(new PersonName("Merry", "Sparacino"));
            people.Add(new PersonName("Sandi", "Willman"));
            people.Add(new PersonName("Damion", "Dagley"));
            DataGrid.ItemsSource = people;
            DataGrid.BeginningEdit += DataGrid_BeginningEdit;
            DataGrid.LoadedRowPresenter += DataGrid_LoadedRowPresenter;
            DataGrid.MouseLeftButtonUp += DataGrid_MouseLeftButtonUp;
            DataGrid.UnloadedRowPresenter += DataGrid_UnloadedRowPresenter;
        }

        void DataGrid_UnloadedRowPresenter(object sender, C1.Silverlight.DataGrid.DataGridRowEventArgs e)
        {
            e.Row.Presenter.MouseLeftButtonUp -= Presenter_MouseLeftButtonUp;
        }

        void DataGrid_LoadedRowPresenter(object sender, C1.Silverlight.DataGrid.DataGridRowEventArgs e)
        {
            e.Row.Presenter.MouseLeftButtonUp += Presenter_MouseLeftButtonUp;
        }
        void DataGrid_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
            this.DataGrid.Selection.Clear();
            for (int i = 0; i <= selectedRows.Count - 1; i++)
            {
                DataGrid.Rows[0].CanUserResize = true;
                this.DataGrid.Selection.Add(new C1.Silverlight.DataGrid.DataGridCellsRange(this.DataGrid.Rows[selectedRows[i]]));
            }
            SelectedRowCountBlock.Text = "Selected RowCount : " + this.DataGrid.Selection.SelectedRows.Count;
        }
        void Presenter_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            int rowIndex = ((C1.Silverlight.DataGrid.DataGridRowPresenter)sender).Row.Index;
            if (!selectedRows.Contains(rowIndex))
            {
                selectedRows.Add(rowIndex);
            }
            else
            {
                selectedRows.Remove(rowIndex);
            }
        }
        void DataGrid_BeginningEdit(object sender, C1.Silverlight.DataGrid.DataGridBeginningEditEventArgs e)
        {
            e.Cancel = true;
        }
        public event PropertyChangedEventHandler PropertyChanged;
    }
    public class PersonName
    {
        // Methods 
        public PersonName(string first, string last)
        {
            this._firstName = first;
            this._lastName = last;
        }
        // Properties 
        public string FirstName
        {
            get { return this._firstName; }
            set { this._firstName = value; }
        }

        public string LastName
        {
            get { return this._lastName; }
            set { this._lastName = value; }
        }
        // Fields 
        private string _firstName;
        private string _lastName;
    }
}
